//
//  MyController.h
//  ImageCalc
//
//  Created by Cameron Hayne on Tue May 21 2002.
//  Copyright (c) 2002 Hayne of Tintagel. All rights reserved.
//

#import <Cocoa/Cocoa.h>
@class MyModel;

typedef struct
{
    NSTimeInterval	startTime;
    NSTimeInterval	lastTime;
    int			lastModelUpdates;
    int			lastViewUpdates;
    int			numUpdates;
    float 		numMegaPoints;
} UpdateInfo;


@interface MyController : NSObject
{
    IBOutlet id 	dataView;
    IBOutlet id 	drawer;
    IBOutlet id 	slider;
    IBOutlet id 	drawerMenuItem;
    IBOutlet id 	modelFpsLabel;
    IBOutlet id 	modelAvgFpsLabel;
    IBOutlet id 	modelMppsLabel;
    IBOutlet id 	modelAvgMppsLabel;
    IBOutlet id 	viewFpsLabel;
    IBOutlet id 	viewAvgFpsLabel;
    IBOutlet id 	viewMppsLabel;
    IBOutlet id 	viewAvgMppsLabel;

    MyModel		*model;
    NSTimer		*timer;    // ensures dataView updates are on main thread
    UpdateInfo		info;      // used for calculating update rates
}

- (void)updateDataView:(NSTimer *)timer;
- (void) updateStatistics;
- (NSData *)data;
- (int)dataVersion;
- (NSLock *)displayLock;
- (IBAction)sliderAction:(id)sender;
- (void)setupDrawer;
- (void)drawerStateChanged:(NSNotification *)notification;
- (IBAction)drawerButtonAction:(id)sender;

@end
